package ru.landgrafhomyak.serdha.api.v0.ddl

public interface ModuleTemplate<ModuleUserExtension : Any> {
	public interface Creator {
		public fun <NewModuleUserExtension : Any> createTemplate(
			versionKey: String,
			updater: CreateModule<NewModuleUserExtension>,
		): ModuleTemplate<NewModuleUserExtension>

		public fun <OldModuleUserExtension : Any, NewModuleUserExtension : Any> upgradeTemplate(
			versionKey: String,
			updater: UpgradeModule<OldModuleUserExtension, NewModuleUserExtension>,
		): ModuleTemplate<NewModuleUserExtension>
	}

	public interface CreateModule<ModuleUserExtension : Any> {
		public fun createModule(rootNs: Namespace, creator: ModuleCreator): ModuleUserExtension
	}

	public interface UpgradeModule<OldModuleUserExtension : Any, NewModuleUserExtension : Any> {
		public fun upgradeModule(oldModule: Module<OldModuleUserExtension>, rootNs: Namespace, updater: ModuleCreator): NewModuleUserExtension
	}

	public val versionKey: String
}